package impl.jaxb;

import impl.jaxb.generated.CellType;

import javax.ws.rs.ProduceMime;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.ext.Provider;
import javax.ws.rs.ext.MessageBodyWriter;
import javax.xml.stream.XMLStreamWriter;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import java.io.OutputStream;
import java.io.IOException;
import java.io.StringWriter;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;

import com.sun.xml.fastinfoset.stax.StAXDocumentSerializer;


/**
 * Created by IntelliJ IDEA.
 * User: arul
 * Date: May 15, 2008
 * Time: 10:16:39 AM
 * To change this template use File | Settings | File Templates.
 */
@ProduceMime("application/xml")
@Provider
public class CDATAProvider implements MessageBodyWriter<CellType> {

    public void writeTo(CellType cellType,
            Class<?> type, Type genericType, Annotation annotations[],
            MediaType mediaType, MultivaluedMap<String, Object> headers,
            OutputStream out) throws IOException {
      try {
        System.out.println("Invoking CDATA provider...");
        JAXBContext jc = JAXBContext.newInstance(CellType.class);
        Marshaller marshaller = jc.createMarshaller();
        XMLStreamWriter swImpl = XMLOutputFactory.newInstance().createXMLStreamWriter(out);
        XMLStreamWriter sw = new MyStreamWriter(swImpl);
        marshaller.marshal(cellType, sw);
      } catch (XMLStreamException xse) {
        System.out.println(xse.getMessage());
      } catch (JAXBException je) {
        System.out.println(je.getMessage());
      }
    }

    public boolean isWriteable(Class<?> type, Type genericType, Annotation annotations[]) {
        return CellType.class.isAssignableFrom(type);
    }

    public long getSize(CellType cellType) {
        return -1;
    }
}

