package impl.jaxb;

import javax.xml.stream.XMLStreamWriter;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.namespace.NamespaceContext;
import java.io.StringWriter;

/**
 * Created by IntelliJ IDEA.
 * User: arul
 * Date: May 14, 2008
 * Time: 1:33:41 PM
 * To change this template use File | Settings | File Templates.
 */
public class MyStreamWriter implements XMLStreamWriter {
  private XMLStreamWriter mImpl;

  public MyStreamWriter(XMLStreamWriter xmlStreamWriter) throws XMLStreamException {
    this.mImpl = xmlStreamWriter;
  }

  public void close() throws XMLStreamException {
    mImpl.close();
  }

  public void flush() throws XMLStreamException {
    mImpl.flush();
  }

  public NamespaceContext getNamespaceContext() {
    return mImpl.getNamespaceContext();
  }

  public String getPrefix(String s) throws XMLStreamException {
    return mImpl.getPrefix(s);
  }

  public Object getProperty(String s) throws IllegalArgumentException {
    return mImpl.getProperty(s);
  }

  public void setDefaultNamespace(String s) throws XMLStreamException {
    mImpl.setDefaultNamespace(s);
  }

  public void setNamespaceContext(NamespaceContext namespaceContext) throws XMLStreamException {
    mImpl.setNamespaceContext(namespaceContext);
  }

  public void setPrefix(String s, String s1) throws XMLStreamException {
    mImpl.setPrefix(s, s1);
  }

  public void writeAttribute(String s, String s1) throws XMLStreamException {
    mImpl.writeAttribute(s, s1);
  }

  public void writeAttribute(String s, String s1, String s2) throws XMLStreamException {
    mImpl.writeAttribute(s, s1, s2);
  }

  public void writeAttribute(String s, String s1, String s2, String s3) throws XMLStreamException {
    mImpl.writeAttribute(s, s1, s2, s3);
  }

  public void writeCData(String s) throws XMLStreamException {
    mImpl.writeCData(s);
  }

  public void writeCharacters(char[] chars, int i, int i1) throws XMLStreamException {
    mImpl.writeCharacters(chars, i, i1);
  }

  public void writeCharacters(String s) throws XMLStreamException {
    System.out.println("writeCharacters : " + s);
//    if (shouldUseCData(s)) {
//      System.out.println("Using CDATA");
      mImpl.writeCData(s);
//    } else {
//      mImpl.writeCharacters(s);
//    }
  }

  private boolean shouldUseCData(String s) {
    if (s.contains("progressOuterRow")) {
      return true;
    }
    return false;
  }

  public void writeComment(String s) throws XMLStreamException {
    mImpl.writeComment(s);
  }

  public void writeDefaultNamespace(String s) throws XMLStreamException {
    mImpl.writeDefaultNamespace(s);
  }

  public void writeDTD(String s) throws XMLStreamException {
    mImpl.writeDTD(s);
  }

  public void writeEmptyElement(String s) throws XMLStreamException {
    mImpl.writeEmptyElement(s);
  }

  public void writeEmptyElement(String s, String s1) throws XMLStreamException {
    mImpl.writeEmptyElement(s, s1);
  }

  public void writeEmptyElement(String s, String s1, String s2) throws XMLStreamException {
    mImpl.writeEmptyElement(s, s1, s2);
  }

  public void writeEndDocument() throws XMLStreamException {
    mImpl.writeEndDocument();
  }

  public void writeEndElement() throws XMLStreamException {
    mImpl.writeEndElement();
  }

  public void writeEntityRef(String s) throws XMLStreamException {
    mImpl.writeEntityRef(s);
  }

  public void writeNamespace(String s, String s1) throws XMLStreamException {
    mImpl.writeNamespace(s, s1);
  }

  public void writeProcessingInstruction(String s) throws XMLStreamException {
    mImpl.writeProcessingInstruction(s);
  }

  public void writeProcessingInstruction(String s, String s1) throws XMLStreamException {
    mImpl.writeProcessingInstruction(s, s1);
  }

  public void writeStartDocument() throws XMLStreamException {
    mImpl.writeStartDocument();
  }

  public void writeStartDocument(String s) throws XMLStreamException {
    mImpl.writeStartDocument(s);
  }

  public void writeStartDocument(String s, String s1) throws XMLStreamException {
    mImpl.writeStartDocument(s, s1);
  }

  public void writeStartElement(String s) throws XMLStreamException {
    mImpl.writeStartElement(s);
  }

  public void writeStartElement(String s, String s1) throws XMLStreamException {
    mImpl.writeStartElement(s, s1);
  }

  public void writeStartElement(String s, String s1, String s2) throws XMLStreamException {
    mImpl.writeStartElement(s, s1, s2);
  }
}
