package impl.resource;

import com.sun.ws.rest.spi.resource.Singleton;

import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.ProduceMime;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.CacheControl;
import java.text.SimpleDateFormat;
import java.util.Locale;
import java.util.Date;
import java.util.List;
import java.util.ArrayList;
import java.io.IOException;

import impl.jaxb.generated.Rows;
import impl.jaxb.generated.RowType;
import impl.jaxb.generated.CellType;

/**
 * Created by IntelliJ IDEA.
 * User: arul
 * Date: May 23, 2008
 * Time: 8:39:25 AM
 * To change this template use File | Settings | File Templates.
 */
@Singleton
@Path("/")
public class RowsResource {

  public static final String HTTP_RESPONSE_DATE_HEADER = "EEE, dd MMM yyyy HH:mm:ss zzz";
  private static final String DATE_ONE = (new SimpleDateFormat(HTTP_RESPONSE_DATE_HEADER, Locale.US)).format(new Date(1));

  @GET
  @Path("/rows")
  @ProduceMime({"application/xml"})
  public Response getRows() throws IOException {
    System.out.println("----invoking getRows operation with no caching ...");
    final Rows rows;
    rows = processRowsResponse();
    CacheControl c = new CacheControl();
    c.setNoCache(true);
    Response.ResponseBuilder rb = Response.ok(rows).cacheControl(c);
    rb.header("Pragma", "no-cache");
    rb.header("Expires", DATE_ONE);
    return rb.build();
  }

  private Rows processRowsResponse() {
    List<RowType> rows = new ArrayList<RowType>();
    RowType row = new RowType();
    CellType cell = new CellType();
    final String cdata = new StringBuilder().append("<div class=\"progressOuterRow\"><div class=\"progressInnerRow\" style=\"width: ").append("25.0").append("px;\"></div><div class=\"progressText\">").append("25").append("/").append("100").append(" MB</div></div>").toString();
    cell.setValue(cdata);
    row.getCell().add(cell);
    rows.add(row);
    final Rows rowsRoot = new Rows();
    rowsRoot.getRow().addAll(rows);
    return rowsRoot;
  }


}
